lexer grammar JSON;
options {
  language=Java;

}
@header {
//--------------------------------------
// XerialJ Project
//
// JSONLexer.java
// Since: Apr 26, 2007
//
//--------------------------------------
package org.xerial.json.impl;
}

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 56
Colon: ':';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 57
Comma: ',';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 58
LBrace: '{';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 59
RBrace: '}';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 60
LBracket: '[';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 61
RBracket: ']';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 62
fragment Dot: '.';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 63
TRUE:  'true';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 64
FALSE: 'false';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 65
NULL: 'null';

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 67
fragment Digit: '0' .. '9';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 68
fragment HexDigit: ('0' .. '9' | 'A' .. 'F' | 'a' .. 'f');
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 69
fragment UnicodeChar: ~('"'| '\\');
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 70
fragment StringChar :  UnicodeChar | EscapeSequence;

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 72
fragment EscapeSequence
	: '\\' ('\"' | '\\' | '/' | 'b' | 'f' | 'n' | 'r' | 't' | 'u' HexDigit HexDigit HexDigit HexDigit)
	;

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 76
fragment Int: '-'? ('0' | '1'..'9' Digit*);
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 77
fragment Frac: Dot Digit+;
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 78
fragment Exp: ('e' | 'E') ('+' | '-')? Digit+;

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 80
WhiteSpace: (' ' | '\r' | '\t' | '\u000C' | '\n') { $channel=HIDDEN; };

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 82
String: '"' StringChar* '"';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 83
Integer: Int;
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 84
Double:  Int (Frac Exp? | Exp);

// parser rules
