lexer grammar DTD;
options {
  language=Java;

}
@header {
//--------------------------------------------------
// Xerial -- Transactional XML Database System      
// 
// DTDLexer.g
// Since  2007/07/25 11:40:17
// 
//--------------------------------------------------

package org.xerial.util.xml.dtd.impl;
import org.xerial.util.log.Logger;

}
@rulecatch {
catch(RecognitionException e){
	Logger.getLogger(this.getClass()).warn(e);
}
}

T29 : '>' ;
T30 : 'EMPTY' ;
T31 : 'ANY' ;
T32 : '?' ;
T33 : '*' ;
T34 : '+' ;
T35 : '|' ;
T36 : '#PCDATA' ;
T37 : '<!ATTLIST' ;
T38 : 'NOTATION' ;
T39 : 'CDATA' ;
T40 : 'ID' ;
T41 : 'IDREF' ;
T42 : 'IDREFS' ;
T43 : 'ENTITY' ;
T44 : 'ENTITIES' ;
T45 : 'NMTOKEN' ;
T46 : 'NMTOKENS' ;

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 67
ML_COMMENT
    :   '<!--' (options {greedy=false;} : .)* '-->' {$channel=HIDDEN;}
    ;

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 71
At: '@';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 72
Colon: ':';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 73
Comma: ',';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 74
Apos: '\'';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 75
Quot: '"';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 76
Dot: '.';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 77
SemiColon: ';';

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 79
LParen: '(';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 80
RParen: ')';

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 82
fragment Letter: 'a' .. 'z' | 'A' .. 'Z';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 83
fragment Digit: '0' .. '9';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 84
Digits: (Digit)+;

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 86
fragment NameChar: Letter | Digit | '_' | '-' | At;

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 88
WhiteSpaceChar: ( ' ' | '\t' | '\n' | '\r' | '\u000C')+ { $channel=HIDDEN; };

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 90
StringLiteral
: Quot! (~'"')* Quot!
| Apos! (~'\'')* Apos!;

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 94
Name: (Letter | '_') NameChar*;


// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 97
fragment AttValue: 
    Quot (~('<' | '&' | Quot) | Reference)* Quot 
    | Apos (~('<' | '&' | Apos) | Reference)* Apos 
	; 
	
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 102
Reference: EntityRef | CharRef;
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 103
fragment EntityRef: '&' Name SemiColon;
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 104
fragment CharRef: '&#' ('0'..'9')+ SemiColon | '&#x' ('0'..'9' | 'a'..'f' | 'A'..'F')+ SemiColon
	;
	
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 107
DefaultDecl: '#REQUIRED' | '#IMPLIED' | ('#FIXED'? AttValue); 

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 109
Element: '<!ELEMENT';



